unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Button3: TButton;
    Button4: TButton;
    Button2: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure outport(address: word; value: byte);
    procedure initLCD;
    procedure LCD_WriteControl(data: byte);
    procedure LCD_WriteData(data: byte);
    procedure LCD_writestring(value : string );
    procedure LCD_Clear;
    procedure LCD_DisplayOff;
    procedure LCD_DisplayOn;
    procedure LCD_CursorOn;
    procedure LCD_CursorOFF;
    procedure LCD_CursorOnWIthBLINK;
    procedure LCD_setRAMAddress(data : byte);
    procedure LCD_DefineChar (address: byte; pattern: array of byte);
  end;

const
        LPT = $378;
        LCD_DATA_ADDRESS = LPT + 0;
        LCD_CONTROL_ADDRESS = LPT + 2;
var
  Form1: TForm1;
        LCD_CHAR_UP_ARROW : array[1..8] of byte = (
	$1f,		// ---11111
	$1b,		// ---11011
	$11,		// ---10001
	$0a,		// ---01010
	$1b,		// ---11011
	$1b,		// ---11011
	$1b,		// ---11011
	$1f 		// ---11111
);



implementation

{$R *.dfm}

{ TForm1 }

procedure TForm1.initLCD;
begin
	LCD_WriteControl($38);
	LCD_WriteControl($06);
//        LCD_WriteControl($0F);
end;

procedure TForm1.outport(address: word; value: byte);
begin
        asm
                mov dx,address
                mov al,value
                out dx,al
        end;
end;

procedure TForm1.LCD_WriteControl(data: byte);
begin
	outport(LCD_CONTROL_ADDRESS,$02); // 16 RS=0  C2, 14 R/W=0  C1, 1 E=1 C0
        outport(LCD_DATA_ADDRESS,data);
	outport(LCD_CONTROL_ADDRESS,$03); // RS=0, R/W=0, E=0
        sleep(10);
end;

procedure TForm1.LCD_WriteData(data: byte);
begin
	outport(LCD_CONTROL_ADDRESS,$06);         // RS=1, R/W=0, E=1
        outport(LCD_DATA_ADDRESS,data);
	outport(LCD_CONTROL_ADDRESS,$07);	// RS=1, R/W=0, E=0
        sleep(1);
end;



procedure TForm1.Button1Click(Sender: TObject);
begin
        initLCD;
    
end;

procedure TForm1.LCD_writestring(value: string);
var
        a: integer;
        i: integer;
begin
        for i:= 1 to length(value) do
        begin
                if (i mod 16) = 0 then
                begin
                        a := i div 16;

                        case a of
                                1 : LCD_setRAMAddress($40);
                                2 : LCD_setRAMAddress($10);
                                3 : LCD_setRAMAddress($50);
                                4 : LCD_setRAMAddress($0);
                        end;

                end;
                 LCD_writedata(ord(value[i]));
        end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
        LCD_writestring(edit1.text);
end;

procedure Tform1.LCD_Clear;
begin
        LCD_writecontrol(1);
end;

procedure Tform1.LCD_DisplayOff;
begin
        LCD_writecontrol($8);
end;

procedure Tform1.LCD_DisplayOn;
begin
        LCD_writecontrol($C);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
        LCd_DisplayOn;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
        LCd_DisplayOff;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
        LCD_Clear;
end;

procedure TForm1.LCD_CursorOn;
begin
        LCD_writecontrol($E);
end;

procedure TForm1.LCD_CursorOnWIthBLINK;
begin
        LCD_writecontrol($F);
end;


procedure TForm1.LCD_CursorOFF;
begin
        LCD_writecontrol($C);
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
        LCD_cursorOn;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
        LCD_cursorOnWithBlink;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
        LCD_cursorOff;
end;

procedure TForm1.LCD_setRAMAddress(data: byte);
var
        temp: byte;
begin
        temp := data or $80;
        LCD_writecontrol(temp);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
        LCD_setRAMAddress($40);
        LCD_writestring('hi');
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
        LCD_setRAMAddress($50);
        LCD_writestring('hi');
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
        LCD_DefineChar(1, LCD_CHAR_UP_ARROW);
end;

procedure Tform1.LCD_DefineChar (address: byte; pattern: array of byte);
var
        i: integer;
begin

	LCD_WriteControl($40 + (address shr 2));
	for i := 1 to 8 do
        begin
		LCD_WriteData(pattern[i]);
	end
end;


end.
